// ContentBlockDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "patriot.h"
#include "ContentBlockDlg.h"
#include "patriotGlobalDom.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CContentBlockDlg _CAO


CContentBlockDlg::CContentBlockDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CContentBlockDlg::IDD, pParent)
	, m_pDisp(0)	//+++
{
	//{{AFX_DATA_INIT(CContentBlockDlg)
	m_strInput = _T("");
	m_nFilter  = -1;
	//}}AFX_DATA_INIT
}


void CContentBlockDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CContentBlockDlg)
	DDX_Text(pDX, IDC_EDIT1, m_strInput);
	DDX_CBIndex(pDX, IDC_COMBO1, m_nFilter);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CContentBlockDlg, CDialog)
	//{{AFX_MSG_MAP(CContentBlockDlg)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST1, OnItemchangedList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CContentBlockDlg bZ[W nh

/// eLXg擾
CString CContentBlockDlg::GetInput( LPDISPATCH pDisp )
{
	m_pDisp = pDisp;

	if (DoModal() == IDOK) {
		CString strInput = m_strInput;
		switch (m_nFilter) {
		case 1:
			strInput = strInput + _T('*');
			break;
		case 2:
			strInput = _T('*') + strInput;
			break;
		case 3:
			strInput = _T('*') + strInput + _T('*');
			break;
		}
		return strInput;
	}
	return	_T("");
}

/// vfURL擾
CString CContentBlockDlg::GetUrlFromElement(LPDISPATCH pDisp)
{
	CString strTagName = GetElementTagName(pDisp);
	if (strTagName.IsEmpty()) {
		return _T("");
	}
	// 摜EIFRAMEEFlash ɃtH[JXꍇ
	if (strTagName == _T("A") || strTagName == _T("IFRAME") || strTagName == _T("SCRIPT") || strTagName == _T("OBJECT")) {
		int nSrcStart = -1;

		CComBSTR bstrHtml;
		CComQIPtr<IHTMLElement> spElement = pDisp;
		spElement->get_outerHTML(&bstrHtml);
		CString strHtml = bstrHtml;

		// URL ̊Jnʒu擾
		if (strTagName == _T("A")) {
			int nFind = strHtml.Find( _T("<IMG") );
			if (nFind > -1) {
				nSrcStart = strHtml.Find( _T("src=\""), nFind + 4 ) + 5;
			}
		}
		else if (strTagName == _T("IFRAME") || strTagName == _T("SCRIPT")) {
			nSrcStart = strHtml.Find( _T("src=\"") );
			if (nSrcStart > -1) {
				nSrcStart += 5;
			}
		} else if (strTagName == _T("OBJECT")) {
			nSrcStart = strHtml.Find( _T("<PARAM NAME=\"Movie\" VALUE=\"") );
			if (nSrcStart == -1) {
				nSrcStart = strHtml.Find( _T("<PARAM NAME=\"Src\" VALUE=\"") );
				if (nSrcStart > -1) {
					nSrcStart += 25;
				}
			} else {
				nSrcStart += 27;
			}
		}
		// URL lɐݒ
		if (nSrcStart > -1) {
			CString strURL = strHtml.Mid( nSrcStart, strHtml.Find( _T('\"'), nSrcStart ) - nSrcStart );

			//΃pXϊ
			if (strURL.Find(_T("://")) == -1) {
				if (strURL.GetAt(0) == _T('/')) {
					strURL = strURL.Mid(1);
				} else if (strURL.Left(2) == _T("./")) {
					strURL = strURL.Mid(3);
				}
				strURL = m_strRootURL + strURL;
			}
			return strURL;
		}
	}
	return _T("");
}

BOOL CContentBlockDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CListCtrl* pList1 = static_cast<CListCtrl*>( GetDlgItem(IDC_LIST1) );
	pList1->SetExtendedStyle(LVS_EX_FULLROWSELECT);
	pList1->InsertColumn( 0, _T("URL"),  LVCFMT_LEFT, 300 );
	pList1->InsertColumn( 1, _T("^O"), LVCFMT_LEFT, 80 );

	// y[W URL 𒊏o
	CComPtr<IDispatch> spDisp = m_pDisp;
	CComQIPtr<IHTMLDocument2> spHtmlDocument = spDisp;

	// [g URL
	CComBSTR bstrURL;
	spHtmlDocument->get_URL(&bstrURL);
	m_strRootURL = bstrURL;
	m_strRootURL = m_strRootURL.Left( m_strRootURL.ReverseFind(_T('/')) + 1);

	// ftHgURL
	CComPtr<IHTMLElement> spElement;
	spHtmlDocument->get_activeElement(&spElement);
	m_strDefault = GetUrlFromElement(spElement);

	// URLXgɒǉ
	CComPtr<IHTMLElementCollection> spElementCollection;
	spHtmlDocument->get_all( &spElementCollection );

	if ( spElementCollection == NULL ) {
		return TRUE;
	}

	VARIANT varIndex = {0}, varNull = {0};
	long nLength;
	spElementCollection->get_length( &nLength );

	for ( int i = 0; i < nLength; i++ ) {
		varIndex.vt 	= VT_UINT;
		varIndex.lVal	= i;

		// IHTMLElement
		CComQIPtr<IDispatch> spDisp;
		spElementCollection->item( varIndex, varNull, &spDisp );

		CComQIPtr<IHTMLElement> spElement = spDisp;
		if (spElement) {
			CString strURL = GetUrlFromElement(spElement);
			if (!strURL.IsEmpty()) {
				CComBSTR bstr;
				spElement->get_tagName(&bstr);
				CString strTagName = bstr;
				if (bstr == _T("A")) {
					strTagName = _T("IMG");
				}

				int nItemCount = pList1->GetItemCount();
				pList1->InsertItem( nItemCount, strURL );
				pList1->SetItemText( nItemCount, 1, strTagName );

				if (strURL == m_strDefault) {
					pList1->SetItemState(nItemCount, 2, LVIS_SELECTED);
					pList1->EnsureVisible(nItemCount, TRUE);
				}
			}
		}
	}

	// ChJ[hϊďlݒ
	int nFilterIndex  = 0;
	int nFindAsterisk = m_strDefault.Find(_T('*'));
	int nFindQuestion = m_strDefault.Find(_T('?'));
	if (nFindQuestion == -1 && nFindAsterisk != -1) {
		if (nFindAsterisk == 0) {
			nFilterIndex = 1;
		} else if (nFindAsterisk == m_strDefault.GetLength() - 1) {
			nFilterIndex = 2;
		}
	}
	CComboBox* pCombo = static_cast<CComboBox*>( GetDlgItem(IDC_COMBO1) );
	pCombo->SetCurSel(nFilterIndex);

	SetDlgItemText( IDC_EDIT1, m_strDefault );

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CContentBlockDlg::OnItemchangedList1(NMHDR* pNMHDR, LRESULT* pResult)
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	int nIndex = pNMListView->iItem;

	if (nIndex >= 0) {
		CListCtrl* pList1 = static_cast<CListCtrl*>( GetDlgItem(IDC_LIST1) );
		CString strURL = pList1->GetItemText( nIndex, 0 );
		SetDlgItemText( IDC_EDIT1, strURL );
	}
	*pResult = 0;
}
