///////////////////////////////////////////////////////////////////
//	GlobalOption.cpp
//	PatriotŜ̐ݒ
///////////////////////////////////////////////////////////////////


#include "stdafx.h"
#include "GlobalOption.h"
#include "patriotGlobal2.h"

CGlobalOption::CGlobalOption()
  #if 0 //+++ 
	: FilterUse(TRUE)
	, FilterUseFirst(TRUE)
	, TabMode(TRUE)
	, MouseTabWheel(0)
	, MouseMinPixel(30)
	, bAutoHideMode(TRUE)
	, nIEVersion(0)
  #else //+++ ԔAʂ菉Ă.
	: StartAction(0)
	, bOffline(0)
	, bAlertUnload(0)
	, bAlertSelected(0)
	, bAlertCloseAll(0)
	, bAlertCloseExcept(0)
	, bDeleteTemporary(0)
	, bDeleteCookie(0)
	, bDeleteHistory(0)
	, bShowStatus(0)
	, bShowTitle(0)
	, bNotMailto(0)
	, bActiveCommand(0)
	, bRegisterAsBrowser(0)
	, bCloseStartupApp(0)
	, strAppPath()
	, strOptionPath()
	, strStartupAppPath()
	, strUrllistPath()
	, strUserAgent()
	, bAutoHideMode(TRUE)
	, bAsNavigateLock(0)
	, bTablockWhenShift(0)
	, bTravellogRestore(0)
	, bPopupResize(0)
	, bNWFavorites(0)
	, bNWHistory(0)
	, bNWUsedurl(0)
	, bNWSendstr(0)
	, bNWAddress(0)
	, bNWLinkbar(0)
	, bATFavorites(0)
	, bATHistory(0)
	, bATUsedurl(0)
	, bATSendstr(0)
	, bATAddress(0)
	, bATLinkbar(0)
	, AutoRefresh(0)
	, CurSidebar(0)
	, nIEVersion(0)
	, TabWidth(0)
	, TabTitleWidth(0)
	, TabTitleWidthMin(0)
	, TabMax(0)
	, TabWlClick(0), TabDbClick(0), TabRtClick(0)
	, TabSlClick(0), TabSwClick(0), TabSrClick(0)
	, TabLrClick(0)
	, TabPosAdd(0)
	, TabPosDel(0)
	, TabFontSize(0)
	, TabMode(TRUE)
	, TabMulti(0)
	, TabButton(0)
	, TabUnder(0)
	, TabLoop(0)
	, TabImg(0)
	, TabImgNomal(0)
	, TabImgTablock(0)
	, TabUseWheel(0)
	, TabFontB(0)			, TabFontU(0)		, TabFontI(0)
	, TabFontColor(0)		, TabBackColor(0)
	, TabSelFontB(0)		, TabSelFontU(0)	, TabSelFontI(0)
	, TabSelFontColor(0)	, TabSelBackColor(0)
	, ToolText(0)
	, ToolBigIcon(0)
	, ToolFixed(0)
	, strToolbar()
	, AddressGoHistory(0)
	, AddressAutoComplete(0)
	, AddressAddSendurl(0)
	, AddressShowIcon(0)
	, AddressHistoryCount(0)
	, strAddressCtrl1()
	, strAddressCtrl2()
	, strAddressCtrl3()
	, SearchUseSendstr(0)
	, SearchGoItemChanged(0)
	, SearchHistoryCount(0)
	, strSearchCtrl1()
	, strSearchCtrl2()
	, strSearchCtrl3()
	, FavoritesShowHide(0)
	, FavoritesAllFolder(0)
	, FavoritesAddHere(0)
	, FavoritesAddComdlg(0)
	, FavoritesIERegist(0)
	, FavoritesOperateOrder(0)
	, FavoritesMaxTitle(0)
	, FavoritesMenuBreak(0)
	, strFavorites()
	, HistorySortDate(0)
	, HistorySortCount(0)
	, LinkImage(0)
	, LinkText(0)
	, LinkLoadImage(0)
	, SidebarTabUnder(0)
	, SidebarAutoHide(0)
	, SidebarNeglectWidth(0)
	, FilterUse(TRUE)
	, FilterUseFirst(TRUE)
	, KeyMode(0)
	, KeyViewOnly(0)
	, MouseTabWheel(0)
	, MouseUseContext(0)
	, MouseDefaultContext(0)
	, MouseSelectedContext(0)
	, MouseUseGesture(0)
	, MouseDrawLine(0)
	, MouseMinPixel(30)
	, MouseLineColor(0)
	, MouseTextColor(0)
	, MouseViewDnD(0)		//+++
	, defoAntiPopup(0)
	, defoLoadImage(0)
	, defoLoadBgm(0)
	, defoLoadVideo(0)
	, defoRunScript(0)
	, defoRunJava(0)
	, defoRunActivex(0)
	, defoLoadActivex(0)
	, defoSilent(0)
	, defoCookie(0)
	, defoCookieSession(0)
	, defoNavigateLock(0)
	, defoTabLock(0)
	, bCookie(0)
	, bCookieSession(0)
	, bCookieIe6(0)
	, bCloseErrorDlg(0)
	, SecurityRefresh(0)
	, SecuritySucceed(0)
	, ProxyPath()
	, ProxyBypass()
	, UseCustomAccel(0)
	, UseCustomContext(0)
	, UseCustomTabmenu(0)
	, ClosedCount(0)
	, BackupMode(0)
	, ClosedSave(0)
	, ClosedDelWhenOpen(0)
	, ThumbnailSize(0)
	, ThumbnailNoImage(0)
	, strDownloadFilter()
	, bContentBlockUse(0)
	, arrContentFilter()
	, arrContentFilterCounts()
  #endif
{
}


/// ݒtH_Ȃǂ̈ʒu擾
void CGlobalOption::LoadFolderPath()
{
	// bura.exêtH_
	TCHAR lpszAppPath[MAX_PATH];
	lstrcpyn( lpszAppPath, AfxGetApp()->m_pszHelpFilePath, MAX_PATH );
	*_tcsrchr( lpszAppPath, _T('\\') ) = 0;
	strAppPath = lpszAppPath;

	// GetUserName
	TCHAR lpszUserName[MAX_PATH];
	DWORD dwSize = MAX_PATH;
	if (::GetUserName(lpszUserName, &dwSize) == 0) {
		lstrcpyn(lpszUserName, _T("All Users"), MAX_PATH);
	}

	// ݒtH_̑݃`FbN
	CString strUserFolder = strAppPath + _T("\\user\\") + lpszUserName;

	WIN32_FIND_DATA  wfd;
	HANDLE hFile = FindFirstFile( strUserFolder, &wfd );

	if (hFile == INVALID_HANDLE_VALUE) {
		// Ȃ default tH_Rs[
		::OperateFile( strAppPath + _T("\\user\\default"), strUserFolder, FO_COPY, FOF_NOCONFIRMMKDIR | FOF_MULTIDESTFILES );
	}
	FindClose(hFile);

	// [U[ݒ̃tH_
	strOptionPath  = strUserFolder + _T("\\setting");
	strUrllistPath = strUserFolder + _T("\\urllist");

	// INIt@C̃pXύX
	if ( AfxGetApp()->m_pszProfileName ) {
		delete[] ((void*)AfxGetApp()->m_pszProfileName);
		AfxGetApp()->m_pszProfileName = new TCHAR[MAX_PATH];

		lstrcpyn( const_cast<LPTSTR>(AfxGetApp()->m_pszProfileName), strOptionPath + _T("\\bura.ini"), MAX_PATH );
	}

}
/// ݒǂݍ
void CGlobalOption::LoadSetting()
{
	LoadFolderPath();
	LoadIni();

	// Ot@C
	GetFavoritesPath();
	LoadBlackList();//}~
	//	LoadMouseGesture();
}

/// ݒۑ
void CGlobalOption::SaveSetting()
{
	SaveIni();
}

/// init@CJ
void CGlobalOption::LoadIni()
{
	CWinApp* pApp = AfxGetApp();
	// {ݒ
	strUserAgent		= pApp->GetProfileString( _T("Main"), _T("UserAgent"), _T("") );

	bActiveCommand		= pApp->GetProfileInt( _T("Main"), _T("ActiveCommand")	  , TRUE  );
	bRegisterAsBrowser	= pApp->GetProfileInt( _T("Main"), _T("RegisterAsBrowser"), TRUE  );
	StartAction 		= pApp->GetProfileInt( _T("Main"), _T("DefaultAction")	  , 4	  );
	bOffline			= pApp->GetProfileInt( _T("Main"), _T("Offline")		  , FALSE );
	bShowStatus 		= pApp->GetProfileInt( _T("Main"), _T("StatusShowAddress"), TRUE  );
	bShowTitle			= pApp->GetProfileInt( _T("Main"), _T("TitleShowTag")	  , FALSE );
	AutoRefresh 		= pApp->GetProfileInt( _T("Main"), _T("SecAutoRefresh")   , 300   );
	bNotMailto			= pApp->GetProfileInt( _T("Main"), _T("NotMailto")		  , FALSE );
	ClosedSave			= pApp->GetProfileInt( _T("Main"), _T("SaveClosedURL")	  , TRUE  );
	ClosedCount 		= pApp->GetProfileInt( _T("Main"), _T("SaveClosedCount")  , 10	  );
	ClosedDelWhenOpen	= pApp->GetProfileInt( _T("Main"), _T("DelClosedWhenOpen"), TRUE  );
	BackupMode			= pApp->GetProfileInt( _T("Main"), _T("Backup") 		  , FALSE );
	KeyMode 			= pApp->GetProfileInt( _T("Main"), _T("KeyboardMode")	  , FALSE );
	bAutoHideMode		= pApp->GetProfileInt( _T("Main"), _T("AutoHideMode")	  , FALSE );
	bTravellogRestore	= pApp->GetProfileInt( _T("Main"), _T("SaveTravellog")	  , TRUE  );
	bPopupResize		= pApp->GetProfileInt( _T("Main"), _T("ResizePopup")	  , TRUE  );
	// ^u
	TabButton		= pApp->GetProfileInt( _T("Tab"), _T("Button")		 , TRUE  );
	TabMulti		= pApp->GetProfileInt( _T("Tab"), _T("Multiline")	 , FALSE );
	TabFontSize 	= pApp->GetProfileInt( _T("Tab"), _T("FontSize")	 , 10	 );
	TabMax			= pApp->GetProfileInt( _T("Tab"), _T("MaxCount")	 , 0	 );
	TabWidth		= pApp->GetProfileInt( _T("Tab"), _T("Width")		 , 0	 );
	TabTitleWidth	= pApp->GetProfileInt( _T("Tab"), _T("WidthTitle")	 , 30	 );
	TabTitleWidthMin= pApp->GetProfileInt( _T("Tab"), _T("WidthTitleMin"), 10	 );
	TabPosDel		= pApp->GetProfileInt( _T("Tab"), _T("DeletePos")	 , 1	 );
	TabPosAdd		= pApp->GetProfileInt( _T("Tab"), _T("AddPos")		 , 0	 );
	TabLoop 		= pApp->GetProfileInt( _T("Tab"), _T("Loop")		 , TRUE  );
	TabUnder		= pApp->GetProfileInt( _T("Tab"), _T("Under")		 , FALSE );
	TabRtClick		= pApp->GetProfileInt( _T("Tab"), _T("RightClick")	 , 1	 );
	TabWlClick		= pApp->GetProfileInt( _T("Tab"), _T("WheelClick")	 , 2	 );
	TabDbClick		= pApp->GetProfileInt( _T("Tab"), _T("DoubleClick")  , 3	 );
	TabLrClick		= pApp->GetProfileInt( _T("Tab"), _T("LRClick") 	 , 4	 );
	TabSlClick		= pApp->GetProfileInt( _T("Tab"), _T("ShiftLClick")  , 10	 );
	TabSwClick		= pApp->GetProfileInt( _T("Tab"), _T("ShiftWClick")  , 9	 );
	TabSrClick		= pApp->GetProfileInt( _T("Tab"), _T("ShiftRClick")  , 11	 );
	TabImg			= pApp->GetProfileInt( _T("Tab"), _T("ShowImage")	 , TRUE  );
	TabImgNomal 	= pApp->GetProfileInt( _T("Tab"), _T("ShowImageN")	 , FALSE );
	TabImgTablock	= pApp->GetProfileInt( _T("Tab"), _T("ShowImageT")	 , FALSE );
	TabUseWheel 	= pApp->GetProfileInt( _T("Tab"), _T("UseWheel")	 , TRUE  );
	TabSelFontColor = pApp->GetProfileInt( _T("Tab"), _T("CurFontColor") , GetSysColor(COLOR_HOTLIGHT)/*RGB(255, 255, 255)*/);
	TabSelBackColor = pApp->GetProfileInt( _T("Tab"), _T("CurBackColor") , GetSysColor(COLOR_BTNFACE) /*RGB( 64,  64,  64)*/);
	TabFontColor	= pApp->GetProfileInt( _T("Tab"), _T("FontColor")	 , GetSysColor(COLOR_BTNTEXT) /*RGB(  0,   0,	0)*/);
	TabBackColor	= pApp->GetProfileInt( _T("Tab"), _T("BackColor")	 , GetSysColor(COLOR_BTNFACE) /*RGB(192, 192, 192)*/);
	TabFontB		= pApp->GetProfileInt( _T("Tab"), _T("FontB")		 , FALSE);
	TabFontU		= pApp->GetProfileInt( _T("Tab"), _T("FontU")		 , FALSE);
	TabFontI		= pApp->GetProfileInt( _T("Tab"), _T("FontI")		 , FALSE);
	TabSelFontB 	= pApp->GetProfileInt( _T("Tab"), _T("CurFontB")	 , FALSE);
	TabSelFontU 	= pApp->GetProfileInt( _T("Tab"), _T("CurFontU")	 , FALSE);
	TabSelFontI 	= pApp->GetProfileInt( _T("Tab"), _T("CurFontI")	 , FALSE);
	// ZLeB
	defoAntiPopup		= pApp->GetProfileInt( _T("Security"), _T("OpenAfterClick") , TRUE	);
	defoLoadImage		= pApp->GetProfileInt( _T("Security"), _T("Image")			, TRUE	);
	defoLoadBgm 		= pApp->GetProfileInt( _T("Security"), _T("Bgm")			, TRUE	);
	defoLoadVideo		= pApp->GetProfileInt( _T("Security"), _T("Video")			, TRUE	);
	defoRunScript		= pApp->GetProfileInt( _T("Security"), _T("Script") 		, TRUE	);
	defoRunJava 		= pApp->GetProfileInt( _T("Security"), _T("Java")			, TRUE	);
	defoRunActivex		= pApp->GetProfileInt( _T("Security"), _T("ActiveX")		, TRUE	);
	defoLoadActivex 	= pApp->GetProfileInt( _T("Security"), _T("ActiveX2")		, TRUE	);
	defoSilent			= pApp->GetProfileInt( _T("Security"), _T("Silent") 		, FALSE );
	defoTabLock 		= pApp->GetProfileInt( _T("Security"), _T("TabLock")		, FALSE );
	defoNavigateLock	= pApp->GetProfileInt( _T("Security"), _T("NavigateLock")	, FALSE );
	defoCookie			= pApp->GetProfileInt( _T("Security"), _T("Cookie") 		, TRUE	);
	defoCookieSession	= pApp->GetProfileInt( _T("Security"), _T("Cookie2")		, TRUE	);
	bCookieIe6			= pApp->GetProfileInt( _T("Security"), _T("CookieIE6")		, 0 	);
	bCloseErrorDlg		= pApp->GetProfileInt( _T("Security"), _T("CloseErrorDlg")	, TRUE	);
	SecurityRefresh 	= pApp->GetProfileInt( _T("Security"), _T("Refresh")		, FALSE );
	SecuritySucceed 	= pApp->GetProfileInt( _T("Security"), _T("Succeed")		, TRUE	);
	// Cɓ
	FavoritesShowHide		= pApp->GetProfileInt( _T("Favorites"), _T("ShowHide")		, FALSE );
	FavoritesAllFolder		= pApp->GetProfileInt( _T("Favorites"), _T("ShowFolder")	, TRUE	);
	FavoritesAddHere		= pApp->GetProfileInt( _T("Favorites"), _T("ShowAddHere")	, TRUE	);
	FavoritesAddComdlg		= pApp->GetProfileInt( _T("Favorites"), _T("UseCommonDlg")	, FALSE );
	FavoritesMaxTitle		= pApp->GetProfileInt( _T("Favorites"), _T("MaxTitle")		, 0 	);
	FavoritesIERegist		= pApp->GetProfileInt( _T("Favorites"), _T("LoadIEReg") 	, FALSE );
	FavoritesOperateOrder	= pApp->GetProfileInt( _T("Favorites"), _T("OperateOrder")	, FALSE );
	FavoritesMenuBreak		= pApp->GetProfileInt( _T("Favorites"), _T("MenuBreak") 	, 0 	);
	// No[
	LinkImage	  = pApp->GetProfileInt( _T("Linkbar"), _T("ShowImage"), TRUE );
	LinkText	  = pApp->GetProfileInt( _T("Linkbar"), _T("ShowText"), TRUE );
	LinkLoadImage = pApp->GetProfileInt( _T("Linkbar"), _T("LoadImage"), FALSE );
	// 
	HistorySortDate 	= pApp->GetProfileInt( _T("History"), _T("SortDate") , FALSE );
	HistorySortCount	= pApp->GetProfileInt( _T("History"), _T("SortCount"), 400	 );
	// TCho[
	SidebarTabUnder 	= pApp->GetProfileInt( _T("Sidebar"), _T("TabBottom")	, TRUE	);
	SidebarAutoHide 	= pApp->GetProfileInt( _T("Sidebar"), _T("AutoHide")	, FALSE );
	SidebarNeglectWidth = pApp->GetProfileInt( _T("Sidebar"), _T("NeglectWidth"), FALSE );
	// VEBhE
	bNWFavorites = pApp->GetProfileInt( _T("NewWindow")   , _T("Favrites")	, TRUE );
	bNWHistory	 = pApp->GetProfileInt( _T("NewWindow")   , _T("History")	, TRUE );
	bNWUsedurl	 = pApp->GetProfileInt( _T("NewWindow")   , _T("ClosedUrl") , TRUE );
	bNWSendstr	 = pApp->GetProfileInt( _T("NewWindow")   , _T("SendString"), TRUE );
	bNWAddress	 = pApp->GetProfileInt( _T("NewWindow")   , _T("Address")	, TRUE );
	bNWLinkbar	 = pApp->GetProfileInt( _T("NewWindow")   , _T("Linkbar")	, TRUE );
	// ANeBu
	bATFavorites = pApp->GetProfileInt( _T("ActiveWindow"), _T("Favrites")	, TRUE );
	bATHistory	 = pApp->GetProfileInt( _T("ActiveWindow"), _T("History")	, TRUE );
	bATAddress	 = pApp->GetProfileInt( _T("ActiveWindow"), _T("Address")	, TRUE );
	bATUsedurl	 = pApp->GetProfileInt( _T("ActiveWindow"), _T("ClosedUrl") , TRUE );
	bATSendstr	 = pApp->GetProfileInt( _T("ActiveWindow"), _T("SendString"), TRUE );
	bATLinkbar	 = pApp->GetProfileInt( _T("ActiveWindow"), _T("Linkbar")	, TRUE );

	bAsNavigateLock   = pApp->GetProfileInt( _T("NewWindow"), _T("AsNavigateLock"), FALSE );
	bTablockWhenShift = pApp->GetProfileInt( _T("NewWindow"), _T("TabWhenShift")  , FALSE );
	// vNV
	ProxyPath	   = pApp->GetProfileString( _T("Proxy"), _T("Address"), _T("InternetOption") );
	ProxyBypass    = pApp->GetProfileString( _T("Proxy"), _T("Bypath") , _T("") 			  );
	// tB^
	FilterUse	   = pApp->GetProfileInt( _T("Filter"),  _T("Use")	 , TRUE  );
	FilterUseFirst = pApp->GetProfileInt( _T("Filter"),  _T("UseNew"), FALSE );
	// L[{[h
	KeyViewOnly    = pApp->GetProfileInt( _T("Keyboard"), _T("ViewOnly")   , FALSE );
	UseCustomAccel = pApp->GetProfileInt( _T("Keyboard"), _T("CustomAccel"), FALSE );
	// }EX
	MouseUseContext 	 = pApp->GetProfileInt( _T("Mouse"), _T("UseContextMenu")	  , TRUE  );
	MouseDefaultContext  = pApp->GetProfileInt( _T("Mouse"), _T("DefaultContextMenu") , FALSE );
	MouseSelectedContext = pApp->GetProfileInt( _T("Mouse"), _T("SelectedContextMenu"), TRUE  );
	MouseTabWheel		 = pApp->GetProfileInt( _T("Mouse"), _T("Wheel")			  , 0	  );
	MouseViewDnD		 = pApp->GetProfileInt( _T("Mouse"), _T("ViewDnD")			  , TRUE  );	//+++ ViewłDnD\.
	// WFX`[
	MouseDrawLine	= pApp->GetProfileInt( _T("Gesture"), _T("DrawLine") , TRUE );
	MouseUseGesture = pApp->GetProfileInt( _T("Gesture"), _T("Use") 	 , TRUE );
	MouseMinPixel	= pApp->GetProfileInt( _T("Gesture"), _T("MinPixel") , 30	);
	MouseLineColor	= pApp->GetProfileInt( _T("Gesture"), _T("LineColor"), RGB(160, 160, 160));
	MouseTextColor	= pApp->GetProfileInt( _T("Gesture"), _T("TextColor"), RGB(   0, 80,   0));
	// c[o[
	ToolText		= pApp->GetProfileInt( _T("Toolbar"), _T("ShowText") , FALSE );
	ToolBigIcon 	= pApp->GetProfileInt( _T("Toolbar"), _T("BigIcon")  , FALSE );
	// AhXo[
	AddressShowIcon    = pApp->GetProfileInt( _T("Address"), _T("ShowIcon") 	, TRUE );
	AddressAutoComplete= pApp->GetProfileInt( _T("Address"), _T("AutoComplete") , TRUE );
	AddressGoHistory   = pApp->GetProfileInt( _T("Address"), _T("GoHistory")	, FALSE );
	AddressAddSendurl  = pApp->GetProfileInt( _T("Address"), _T("AddSendURL")	, FALSE );
	AddressHistoryCount= pApp->GetProfileInt( _T("Address"), _T("HistoryCount") , 50	);
	strAddressCtrl1 = pApp->GetProfileString( _T("Address"), _T("Ctrl1")		, _T("o[猟"));
	strAddressCtrl2 = pApp->GetProfileString( _T("Address"), _T("Ctrl2")		, _T("GLTCg|")	);
	strAddressCtrl3 = pApp->GetProfileString( _T("Address"), _T("Ctrl3")		, _T("URLWJ")		);
	// o[
	SearchUseSendstr	= pApp->GetProfileInt( _T("Search"), _T("UseSendstr")	, FALSE 			  );
	SearchGoItemChanged = pApp->GetProfileInt( _T("Search"), _T("GoItemChanged"), TRUE				  );
	SearchHistoryCount	= pApp->GetProfileInt( _T("Search"), _T("HistoryCount") , 20				  );
	strSearchCtrl1	 = pApp->GetProfileString( _T("Search"), _T("Ctrl1")		, _T("y[W"));
	strSearchCtrl2	 = pApp->GetProfileString( _T("Search"), _T("Ctrl2")		, _T("y[W"));
	strSearchCtrl3	 = pApp->GetProfileString( _T("Search"), _T("Ctrl3")		, _T("nCCg")	  );
	// N
	strStartupAppPath = pApp->GetProfileString( _T("Startup"), _T("AppPath"), _T(""));
	bCloseStartupApp  = pApp->GetProfileInt( _T("Startup"), _T("CloseStartupApp"), FALSE);
	// mF
	bAlertUnload	  = pApp->GetProfileInt( _T("Alert")	   , _T("Unload")		  , FALSE );
	bAlertSelected	  = pApp->GetProfileInt( _T("Alert")	   , _T("Selected") 	  , FALSE );
	bAlertCloseAll	  = pApp->GetProfileInt( _T("Alert")	   , _T("CloseAll") 	  , TRUE  );
	bAlertCloseExcept = pApp->GetProfileInt( _T("Alert")	   , _T("CloseExcept")	  , TRUE  );
	// I
	bDeleteTemporary  = pApp->GetProfileInt( _T("Exit") 	   , _T("DeleteTemporary"), FALSE );
	bDeleteCookie	  = pApp->GetProfileInt( _T("Exit") 	   , _T("DeleteCookie")   , FALSE );
	bDeleteHistory	  = pApp->GetProfileInt( _T("Exit") 	   , _T("DeleteHistory")  , FALSE );
	// j[
	UseCustomContext  = pApp->GetProfileInt( _T("CustomMenu")  , _T("UseContext")	  , FALSE );
	UseCustomTabmenu  = pApp->GetProfileInt( _T("CustomMenu")  , _T("UseTabbar")	  , FALSE );
	// _E[h
	strDownloadFilter = pApp->GetProfileString( _T("Download") , _T("Filter")		  , _T(""));
	// TlC
	ThumbnailSize	  = pApp->GetProfileInt( _T("Thumbnail")   , _T("ImageSize")	  , 200   );
	ThumbnailNoImage  = pApp->GetProfileInt( _T("Thumbnail")   , _T("WithoutImage")   , FALSE );
	// RecubN
	bContentBlockUse  = pApp->GetProfileInt( _T("ContentBlock"), _T("Use")			  , TRUE  );
}

/// IȐݒ̕ۑ
void CGlobalOption::SaveDynamicIni()
{
	CWinApp* pApp = AfxGetApp();
	// vNV
	pApp->WriteProfileString( _T("Proxy"), _T("Address"), ProxyPath);
	// o[ŉB
	pApp->WriteProfileInt( _T("Main"), _T("AutoHideMode"), bAutoHideMode );
	// L[{[h[h
	pApp->WriteProfileInt( _T("Main"), _T("KeyboardMode"), KeyMode );
	// c[o[̌Œ
	pApp->WriteProfileInt( _T("Toolbar"), _T("Fixed"), ToolFixed );
	// ŉB
	pApp->WriteProfileInt( _T("Sidebar"), _T("AutoHide"), SidebarAutoHide );
	// xŕ
	pApp->WriteProfileInt( _T("Security"), _T("CloseErrorDlg"), bCloseErrorDlg );

	pApp->WriteProfileInt( _T("History"), _T("SortDate")		 , HistorySortDate );
	pApp->WriteProfileInt( _T("Main")	, _T("StatusShowAddress"), bShowStatus	   );
	pApp->WriteProfileInt( _T("Main")	, _T("TitleShowTag")	 , bShowTitle	   );
	// tB^
	pApp->WriteProfileInt( _T("Filter"), _T("Use"), FilterUse );

	// RecubNۑ
	SaveBlackList();
}

/// init@Cۑ
void CGlobalOption::SaveIni()
{
	CWinApp* pApp = AfxGetApp();
	// {ݒ
	pApp->WriteProfileString( _T("Main"), _T("UserAgent"), strUserAgent );

	pApp->WriteProfileInt( _T("Main"), _T("RegisterAsBrowser"), bRegisterAsBrowser);
	pApp->WriteProfileInt( _T("Main"), _T("ActiveCommand")	  , bActiveCommand	  );
	pApp->WriteProfileInt( _T("Main"), _T("DefaultAction")	  , StartAction 	  );
	pApp->WriteProfileInt( _T("Main"), _T("SecAutoRefresh")   , AutoRefresh 	  );
	pApp->WriteProfileInt( _T("Main"), _T("NotMailto")		  , bNotMailto		  );
	pApp->WriteProfileInt( _T("Main"), _T("SaveClosedURL")	  , ClosedSave		  );
	pApp->WriteProfileInt( _T("Main"), _T("SaveClosedCount")  , ClosedCount 	  );
	pApp->WriteProfileInt( _T("Main"), _T("DelClosedWhenOpen"), ClosedDelWhenOpen );
	pApp->WriteProfileInt( _T("Main"), _T("FavoritesShowHide"), FavoritesShowHide );
	pApp->WriteProfileInt( _T("Main"), _T("Backup") 		  , BackupMode		  );
	pApp->WriteProfileInt( _T("Main"), _T("StatusShowAddress"), bShowStatus 	  );
	pApp->WriteProfileInt( _T("Main"), _T("TitleShowTag")	  , bShowTitle		  );
	pApp->WriteProfileInt( _T("Main"), _T("KeyboardMode")	  , KeyMode 		  );
	pApp->WriteProfileInt( _T("Main"), _T("SaveTravellog")	  , bTravellogRestore );
	pApp->WriteProfileInt( _T("Main"), _T("ResizePopup")	  , bPopupResize	  );

	pApp->WriteProfileInt( _T("History"), _T("SortDate"), HistorySortDate);
	// Cɓ
	pApp->WriteProfileInt( _T("Favorites"), _T("ShowHide")	  , FavoritesShowHide	  );
	pApp->WriteProfileInt( _T("Favorites"), _T("ShowFolder")  , FavoritesAllFolder	  );
	pApp->WriteProfileInt( _T("Favorites"), _T("ShowAddHere") , FavoritesAddHere	  );
	pApp->WriteProfileInt( _T("Favorites"), _T("UseCommonDlg"), FavoritesAddComdlg	  );
	pApp->WriteProfileInt( _T("Favorites"), _T("MaxTitle")	  , FavoritesMaxTitle	  );
	pApp->WriteProfileInt( _T("Favorites"), _T("LoadIEReg")   , FavoritesIERegist	  );
	pApp->WriteProfileInt( _T("Favorites"), _T("OperateOrder"), FavoritesOperateOrder );
	pApp->WriteProfileInt( _T("Favorites"), _T("MenuBreak")   , FavoritesMenuBreak	  );

	pApp->WriteProfileInt( _T("Linkbar"), _T("ShowImage")	  , LinkImage);
	pApp->WriteProfileInt( _T("Linkbar"), _T("ShowText")	  , LinkText );
	pApp->WriteProfileInt( _T("Linkbar"), _T("LoadImage")	  , LinkLoadImage );
	// TCho[
	pApp->WriteProfileInt( _T("Sidebar"),  _T("TabBottom")	  , SidebarTabUnder 	);
	pApp->WriteProfileInt( _T("Sidebar"),  _T("AutoHide")	  , SidebarAutoHide 	);
	pApp->WriteProfileInt( _T("Sidebar"),  _T("NeglectWidth") , SidebarNeglectWidth );
	// ^u
	pApp->WriteProfileInt( _T("Tab"), _T("Button")		 , TabButton);
	pApp->WriteProfileInt( _T("Tab"), _T("Multiline")	 , TabMulti);
	pApp->WriteProfileInt( _T("Tab"), _T("MaxCount")	 , TabMax);
	pApp->WriteProfileInt( _T("Tab"), _T("Width")		 , TabWidth);
	pApp->WriteProfileInt( _T("Tab"), _T("WidthTitle")	 , TabTitleWidth);
	pApp->WriteProfileInt( _T("Tab"), _T("WidthTitleMin"), TabTitleWidthMin);
	pApp->WriteProfileInt( _T("Tab"), _T("Loop")		 , TabLoop);
	pApp->WriteProfileInt( _T("Tab"), _T("Under")		 , TabUnder);
	pApp->WriteProfileInt( _T("Tab"), _T("DeletePos")	 , TabPosDel);
	pApp->WriteProfileInt( _T("Tab"), _T("AddPos")		 , TabPosAdd);

	pApp->WriteProfileInt( _T("Tab"), _T("ShowImage")	 , TabImg);
	pApp->WriteProfileInt( _T("Tab"), _T("ShowImageN")	 , TabImgNomal);
	pApp->WriteProfileInt( _T("Tab"), _T("ShowImageT")	 , TabImgTablock);

	pApp->WriteProfileInt( _T("Tab"), _T("UseWheel")	 , TabUseWheel);

	pApp->WriteProfileInt( _T("Tab"), _T("RightClick")	 , TabRtClick);
	pApp->WriteProfileInt( _T("Tab"), _T("WheelClick")	 , TabWlClick);
	pApp->WriteProfileInt( _T("Tab"), _T("DoubleClick")  , TabDbClick);
	pApp->WriteProfileInt( _T("Tab"), _T("LRClick") 	 , TabLrClick);
	pApp->WriteProfileInt( _T("Tab"), _T("ShiftLClick")  , TabSlClick);
	pApp->WriteProfileInt( _T("Tab"), _T("ShiftWClick")  , TabSwClick);
	pApp->WriteProfileInt( _T("Tab"), _T("ShiftRClick")  , TabSrClick);

	pApp->WriteProfileInt( _T("Tab"), _T("CurFontColor") , TabSelFontColor);
	pApp->WriteProfileInt( _T("Tab"), _T("CurBackColor") , TabSelBackColor);
	pApp->WriteProfileInt( _T("Tab"), _T("FontColor")	 , TabFontColor);
	pApp->WriteProfileInt( _T("Tab"), _T("BackColor")	 , TabBackColor);
	pApp->WriteProfileInt( _T("Tab"), _T("FontB")		 , TabFontB);
	pApp->WriteProfileInt( _T("Tab"), _T("FontU")		 , TabFontU);
	pApp->WriteProfileInt( _T("Tab"), _T("FontI")		 , TabFontI);
	pApp->WriteProfileInt( _T("Tab"), _T("CurFontB")	 , TabSelFontB);
	pApp->WriteProfileInt( _T("Tab"), _T("CurFontU")	 , TabSelFontU);
	pApp->WriteProfileInt( _T("Tab"), _T("CurFontI")	 , TabSelFontI);
	// ZLeB
	pApp->WriteProfileInt( _T("Security"),	_T("OpenAfterClick"), defoAntiPopup);
	pApp->WriteProfileInt( _T("Security"),	_T("Image") 		, defoLoadImage);
	pApp->WriteProfileInt( _T("Security"),	_T("Bgm")			, defoLoadBgm);
	pApp->WriteProfileInt( _T("Security"),	_T("Video") 		, defoLoadVideo);
	pApp->WriteProfileInt( _T("Security"),	_T("Script")		, defoRunScript);
	pApp->WriteProfileInt( _T("Security"),	_T("Java")			, defoRunJava);
	pApp->WriteProfileInt( _T("Security"),	_T("ActiveX")		, defoRunActivex);
	pApp->WriteProfileInt( _T("Security"),	_T("ActiveX2")		, defoLoadActivex);
	pApp->WriteProfileInt( _T("Security"),	_T("Silent")		, defoSilent);
	pApp->WriteProfileInt( _T("Security"),	_T("NavigateLock")	, defoNavigateLock);
	pApp->WriteProfileInt( _T("Security"),	_T("TabLock")		, defoTabLock);
	pApp->WriteProfileInt( _T("Security"),	_T("Cookie")		, defoCookie);
	pApp->WriteProfileInt( _T("Security"),	_T("Cookie2")		, defoCookieSession);
	pApp->WriteProfileInt( _T("Security"),	_T("CookieIE6") 	, bCookieIe6);
	pApp->WriteProfileInt( _T("Security"),	_T("CloseErrorDlg") , bCloseErrorDlg);
	pApp->WriteProfileInt( _T("Security"),	_T("Refresh")		, SecurityRefresh);
	pApp->WriteProfileInt( _T("Security"),	_T("Succeed")		, SecuritySucceed);
	// VEBhE
	pApp->WriteProfileInt( _T("NewWindow"), _T("Favrites")		, bNWFavorites);
	pApp->WriteProfileInt( _T("NewWindow"), _T("History")		, bNWHistory);
	pApp->WriteProfileInt( _T("NewWindow"), _T("Address")		, bNWAddress);
	pApp->WriteProfileInt( _T("NewWindow"), _T("ClosedUrl") 	, bNWUsedurl);
	pApp->WriteProfileInt( _T("NewWindow"), _T("SendString")	, bNWSendstr);
	pApp->WriteProfileInt( _T("NewWindow"), _T("Linkbar")		, bNWLinkbar);

	pApp->WriteProfileInt( _T("NewWindow"), _T("AsNavigateLock"), bAsNavigateLock);
	pApp->WriteProfileInt( _T("NewWindow"), _T("TabWhenShift")	, bTablockWhenShift);
	// ANeBu
	pApp->WriteProfileInt( _T("ActiveWindow"), _T("Favrites")	, bATFavorites);
	pApp->WriteProfileInt( _T("ActiveWindow"), _T("History")	, bATHistory);
	pApp->WriteProfileInt( _T("ActiveWindow"), _T("Address")	, bATAddress);
	pApp->WriteProfileInt( _T("ActiveWindow"), _T("ClosedUrl")	, bATUsedurl);
	pApp->WriteProfileInt( _T("ActiveWindow"), _T("SendString") , bATSendstr);
	pApp->WriteProfileInt( _T("ActiveWindow"), _T("Linkbar")	, bATLinkbar);
	// vNV
	pApp->WriteProfileString( _T("Proxy"), _T("Bypath") , ProxyBypass );
	pApp->WriteProfileString( _T("Proxy"), _T("Address"), ProxyPath   );
	// tB^
	pApp->WriteProfileInt( _T("Filter")  , _T("Use")				, FilterUse);
	pApp->WriteProfileInt( _T("Filter")  , _T("UseNew") 			, FilterUseFirst);
	// }EX
	pApp->WriteProfileInt( _T("Mouse")	 , _T("UseContextMenu") 	, MouseUseContext);
	pApp->WriteProfileInt( _T("Mouse")	 , _T("DefaultContextMenu") , MouseDefaultContext);
	pApp->WriteProfileInt( _T("Mouse")	 , _T("SelectedContextMenu"), MouseSelectedContext);
	pApp->WriteProfileInt( _T("Mouse")	 , _T("Wheel")				, MouseTabWheel);
	pApp->WriteProfileInt( _T("Mouse")	 , _T("ViewDnD")			, MouseViewDnD);	//+++ ViewłDnD\.
	// WFX`[
	pApp->WriteProfileInt( _T("Gesture") , _T("DrawLine")			, MouseDrawLine);
	pApp->WriteProfileInt( _T("Gesture") , _T("Use")				, MouseUseGesture);
	pApp->WriteProfileInt( _T("Gesture") , _T("LineColor")			, MouseLineColor);
	pApp->WriteProfileInt( _T("Gesture") , _T("TextColor")			, MouseTextColor);
	pApp->WriteProfileInt( _T("Gesture") , _T("MinPixel")			, MouseMinPixel);
	// L[{[h
	pApp->WriteProfileInt( _T("Keyboard"), _T("ViewOnly")			, KeyViewOnly);
	pApp->WriteProfileInt( _T("Keyboard"), _T("CustomAccel")		, UseCustomAccel);
	// c[o[
	pApp->WriteProfileInt( _T("Toolbar") , _T("ShowText")			, ToolText);
	pApp->WriteProfileInt( _T("Toolbar") , _T("BigIcon")			, ToolBigIcon);
	pApp->WriteProfileInt( _T("Toolbar") , _T("Fixed")				, ToolFixed);
	// AhXo[
	pApp->WriteProfileInt( _T("Address") , _T("AutoComplete")		, AddressAutoComplete);
	pApp->WriteProfileInt( _T("Address") , _T("GoHistory")			, AddressGoHistory);
	pApp->WriteProfileInt( _T("Address") , _T("AddSendURL") 		, AddressAddSendurl);
	pApp->WriteProfileInt( _T("Address") , _T("HistoryCount")		, AddressHistoryCount);
	pApp->WriteProfileInt( _T("Address") , _T("ShowIcon")			, AddressShowIcon);
	pApp->WriteProfileString( _T("Address"),  _T("Ctrl1")			, strAddressCtrl1);
	pApp->WriteProfileString( _T("Address"),  _T("Ctrl2")			, strAddressCtrl2);
	pApp->WriteProfileString( _T("Address"),  _T("Ctrl3")			, strAddressCtrl3);
	// o[
	pApp->WriteProfileInt( _T("Search"), _T("UseSendstr")	, SearchUseSendstr);
	pApp->WriteProfileInt( _T("Search"), _T("GoItemChanged"), SearchGoItemChanged);
	pApp->WriteProfileInt( _T("Search"), _T("HistoryCount") , SearchHistoryCount);
	pApp->WriteProfileString( _T("Search"), _T("Ctrl1") 	, strSearchCtrl1);
	pApp->WriteProfileString( _T("Search"), _T("Ctrl2") 	, strSearchCtrl2);
	pApp->WriteProfileString( _T("Search"), _T("Ctrl3") 	, strSearchCtrl3);
	// mF
	pApp->WriteProfileInt( _T("Alert"), _T("Unload")		, bAlertUnload);
	pApp->WriteProfileInt( _T("Alert"), _T("Selected")		, bAlertSelected);
	pApp->WriteProfileInt( _T("Alert"), _T("CloseAll")		, bAlertCloseAll);
	pApp->WriteProfileInt( _T("Alert"), _T("CloseExcept")	, bAlertCloseExcept);
	// I
	pApp->WriteProfileInt( _T("Exit"), _T("DeleteTemporary"), bDeleteTemporary);
	pApp->WriteProfileInt( _T("Exit"), _T("DeleteCookie")	, bDeleteCookie);
	pApp->WriteProfileInt( _T("Exit"), _T("DeleteHistory")	, bDeleteHistory);
	// j[
	pApp->WriteProfileInt( _T("CustomMenu"), _T("UseContext")	, UseCustomContext);
	pApp->WriteProfileInt( _T("CustomMenu"), _T("UseTabbar")	, UseCustomTabmenu);
	// TlC
	pApp->WriteProfileInt( _T("Thumbnail") , _T("ImageSize")	, ThumbnailSize);
	pApp->WriteProfileInt( _T("Thumbnail") , _T("WithoutImage") , ThumbnailNoImage);
	// RecubN
	pApp->WriteProfileInt( _T("ContentBlock"), _T("Use")		, bContentBlockUse);
	// _E[h
	pApp->WriteProfileString( _T("Download"), _T("Filter"), strDownloadFilter);
	// N
	pApp->WriteProfileString( _T("Startup"), _T("AppPath")	, strStartupAppPath);
	pApp->WriteProfileInt( _T("Startup"), _T("CloseStartupApp")  , bCloseStartupApp);
}

/// CɓtH_擾
BOOL CGlobalOption::GetFavoritesPath()
{
	CString strTmp = AfxGetApp()->GetProfileString( _T("Favorites"), _T("Path"), _T("") );
	if (!FavoritesIERegist && !strTmp.IsEmpty()) {
		// ƎCɓ
		strFavorites = strTmp;
		if (strFavorites.GetLength() > 2 && strFavorites.Left(2) == _T(".\\")) {
			strFavorites = strAppPath + strFavorites.Mid(1);
			AfxMessageBox(strFavorites);
		}
	} else {
		// WXgǂݍ
		strFavorites = GetRegStr(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\User Shell Folders"), _T("Favorites"), _T("") );
	}
	if (strFavorites.GetLength() > 0 && strFavorites.GetAt(strFavorites.GetLength() - 1) == _T('\\')) {
		strFavorites = strFavorites.Left(strFavorites.GetLength() - 1);
	}
	return 0;
}

/// RecubN̓ǂݍ
void CGlobalOption::LoadBlackList()
{
	arrContentFilter.RemoveAll();
	arrContentFilterCounts.RemoveAll();

	TRY{
		//CStdioFile fin(strOptionPath + _T("\\contentblock.dat"), CFile::modeRead);
		CReadTextFile fin(strOptionPath + _T("\\contentblock.dat"), CFile::modeRead);
		CString str;
		CString strURL, strCount;
		while (fin.ReadString(str)) { // RecubN
			SplitStr(str, _T('\t'), strURL, strCount);
			arrContentFilter.Add(strURL);
			arrContentFilterCounts.Add( ::_ttoi(strCount) );
		}
		fin.Close();
	}
	CATCH( CFileException, e ){
		if ( e->m_cause != CFileException::fileNotFound) {
			TRACE( _T("File could not be opened %d \n")  , e->m_cause);
		}
	}END_CATCH
}

/// RecubN̕ۑ
void CGlobalOption::SaveBlackList()
{
	//+++ CStdioFile fin(strOptionPath + _T("\\contentblock.dat"), CFile::modeCreate | CFile::modeWrite);
	CWriteTextFile fin(strOptionPath + _T("\\contentblock.dat"), CFile::modeCreate | CFile::modeWrite);
	for (int i = 0; i < arrContentFilter.GetSize(); i++){ // RecubN
		CString str = arrContentFilter.GetAt(i) + _T("\t") + ItoStr( arrContentFilterCounts.GetAt(i) ) + _T("\n");
		fin.WriteString( str );
	}
	fin.Close();
}

/// IẼo[W擾
int CGlobalOption::GetIEVersion()
{
	if (nIEVersion == 0) {
		nIEVersion = int(_tcstod( ::GetRegStr(HKEY_LOCAL_MACHINE, _T("Software\\Microsoft\\Internet Explorer"), _T("Version"), _T("")), NULL) * 10);
	}
	return nIEVersion;
}
