// PageFavorites.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageFavorites.h"
//#include "../PatriotGlobal.h"
#include <ShlObj.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageFavorites vpeB y[W

IMPLEMENT_DYNCREATE(CPageFavorites, CPropertyPage)

CPageFavorites::CPageFavorites()
	: CPropertyPage(CPageFavorites::IDD)
{
	//{{AFX_DATA_INIT(CPageFavorites)
	m_ShowFileHide		= FALSE;
	m_FavoritesFolder	= FALSE;
	m_Path				= _T("");
	m_UseComdlg 		= FALSE;
	m_MaxTitle			= 0;
	m_LoadIEReg 		= FALSE;
	m_FavoritesAddHere	= FALSE;
	m_MenuBreak 		= 0;
	m_OperateOrder		= FALSE;
	//}}AFX_DATA_INIT
}

CPageFavorites::~CPageFavorites()
{
}

void CPageFavorites::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageFavorites)
	DDX_Check(pDX, IDC_CHECK1, m_ShowFileHide);
	DDX_Check(pDX, IDC_CHECK2, m_FavoritesFolder);
	DDX_Text(pDX, IDC_EDIT1, m_Path);
	DDX_Check(pDX, IDC_CHECK5, m_UseComdlg);
	DDX_Text(pDX, IDC_EDIT2, m_MaxTitle);
	DDV_MinMaxInt(pDX, m_MaxTitle, 0, 150);
	DDX_Check(pDX, IDC_CHECK6, m_LoadIEReg);
	DDX_Check(pDX, IDC_CHECK7, m_FavoritesAddHere);
	DDX_Text(pDX, IDC_EDIT3, m_MenuBreak);
	DDV_MinMaxInt(pDX, m_MenuBreak, 0, 300);
	DDX_Check(pDX, IDC_CHECK3, m_OperateOrder);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageFavorites, CPropertyPage)
	//{{AFX_MSG_MAP(CPageFavorites)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageFavorites bZ[W nh

void CPageFavorites::OnButton1()
{ // tH_̑I
	CString strPath;
	CString strSelected;
	GetDlgItemText( IDC_EDIT1, strSelected );
	SelectFolderDlg( &strPath, strSelected );
	if (strPath.GetLength() > 1) {
		SetDlgItemText( IDC_EDIT1, strPath );

		UpdateData(TRUE);
		if (!m_UseComdlg && AfxMessageBox( _T("Cɓ̒ǉWindowsW_CAOgp܂H\ngpȂꍇuCɓ̒ǉvœƎtH_ł͂ȂIEW̏ꏊɕۑ܂B")	, MB_YESNO | MB_ICONQUESTION) == IDYES) {
			m_UseComdlg = TRUE;
			UpdateData(FALSE);
		}
	}
}

bool CPageFavorites::SelectFolderDlg(CString* lpstrFolder , CString strIniFolder)
{ // tH_̑I֐
	bool		ret = false;
	LPMALLOC	lpMalloc;

	if (::SHGetMalloc(&lpMalloc) != NOERROR)
		return	false;
	TCHAR			lpszPath[MAX_PATH];
	BROWSEINFO		sInfo;
	LPITEMIDLIST	lpidlBrowse;

	::ZeroMemory(&sInfo, sizeof(BROWSEINFO));
	sInfo.hwndOwner 	= m_hWnd;
	sInfo.pidlRoot		= NULL;
	sInfo.pszDisplayName= lpszPath;
	sInfo.lpszTitle 	= _T("tH_̑I");
	sInfo.ulFlags		= BIF_RETURNONLYFSDIRS/* | BIF_EDITBOX*/;
	sInfo.lpfn			= _SHBrowseForFolderCallbackProc;
	sInfo.lParam		= (LPARAM)strIniFolder.GetBuffer(0);
	// sInfo.iImage 	= NULL;

	// tH_I_CAO\
	lpidlBrowse = ::SHBrowseForFolder(&sInfo);
	if (lpidlBrowse) { // tH_̎擾
		::SHGetPathFromIDList(lpidlBrowse, lpszPath);
		*lpstrFolder = lpszPath;
		ret = true;
	}
	if (lpidlBrowse != NULL)
		::CoTaskMemFree(lpidlBrowse);

	lpMalloc->Release();
	return	ret;
}

void CPageFavorites::OnCheck6()
{ // IEɕׂ
	CButton* pCheck6 = (CButton*)GetDlgItem(IDC_CHECK6);
	GetDlgItem(IDC_CHECK3)->EnableWindow(pCheck6->GetCheck() != 0);
	GetDlgItem(IDC_EDIT1)->EnableWindow(pCheck6->GetCheck() == 0);
	GetDlgItem(IDC_BUTTON1)->EnableWindow(pCheck6->GetCheck() == 0);
}

BOOL CPageFavorites::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// Cɓ
	m_Path				= AfxGetApp()->GetProfileString(_T("Favorites"), _T("Path"), _T(""));
	m_ShowFileHide		= g_Options.FavoritesShowHide;
	m_FavoritesFolder	= g_Options.FavoritesAllFolder;
	m_FavoritesAddHere	= g_Options.FavoritesAddHere;
	m_UseComdlg 		= g_Options.FavoritesAddComdlg;
	m_LoadIEReg 		= g_Options.FavoritesIERegist;
	m_MaxTitle			= g_Options.FavoritesMaxTitle;
	m_MenuBreak 		= g_Options.FavoritesMenuBreak;
	m_OperateOrder		= g_Options.FavoritesOperateOrder;

	UpdateData(FALSE);
	OnCheck6();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CPageFavorites::OnOK()
{ // ݒۑ
	// Cɓ
	AfxGetApp()->WriteProfileString(_T("Favorites"), _T("Path"), m_Path);
	g_Options.FavoritesShowHide 	= m_ShowFileHide;
	g_Options.FavoritesAllFolder	= m_FavoritesFolder;
	g_Options.FavoritesAddHere		= m_FavoritesAddHere;
	g_Options.FavoritesAddComdlg	= m_UseComdlg;
	g_Options.FavoritesIERegist 	= m_LoadIEReg;
	g_Options.FavoritesMaxTitle 	= m_MaxTitle;
	g_Options.FavoritesMenuBreak	= m_MenuBreak;
	g_Options.FavoritesOperateOrder = m_OperateOrder;

	CPropertyPage::OnOK();
}

int CALLBACK _SHBrowseForFolderCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	if (uMsg == BFFM_INITIALIZED) {
		::SendMessage(hwnd, BFFM_SETSELECTION, TRUE, lpData);
	}
	return	0;
}
