/////////////////////////////////////////////////////////////////////////////
// PatriotToolbar.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"

#include "PatriotToolbar.h"
#include "patriotView.h"
#include "MainFrm.h"
#include "patriotGlobal2.h"
#include <vector>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPatriotToolbar

CPatriotToolbar::CPatriotToolbar()
	: m_Font()
	, m_arrButton()
	, m_imgBtnHot()
	, m_imgBtnCool()
	, m_imgBtnDisabled()
{
}

CPatriotToolbar::~CPatriotToolbar()
{
}

BEGIN_MESSAGE_MAP(CPatriotToolbar, CToolBar)
	//{{AFX_MSG_MAP(CPatriotToolbar)
	ON_WM_CREATE()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
//	ON_MESSAGE(WM_IDLEUPDATECMDUI, OnIdleUpdateCmdUI)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPatriotToolbar bZ[W nh

int CPatriotToolbar::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CToolBar::OnCreate(lpCreateStruct) == -1) {
		return -1;
	}
	// ModifyStyle(NULL , TBSTYLE_LIST);
	// GetToolBarCtrl().SetButtonWidth(16 , 20);
	// GetToolBarCtrl().SetDrawTextFlags(DT_WORDBREAK , DT_WORDBREAK);
	// AutoSize();
	// TODO: c[ `bvXKvȂꍇA폜ĂB
	// SetBarStyle(GetBarStyle() | CBRS_TOOLTIPS | CBRS_FLYBY);
	// LoadData();
	GetToolBarCtrl().SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS | TBSTYLE_EX_MIXEDBUTTONS );
	// XP Visual-Style΍BCreateŏȂ
	ModifyStyle(0, TBSTYLE_FLAT | TBSTYLE_TOOLTIPS | CCS_NOMOVEY | TBSTYLE_TRANSPARENT /*| CCS_ADJUSTABLE*/ );
	return 0;
}

LRESULT CPatriotToolbar::OnIdleUpdateCmdUI(WPARAM wParam, LPARAM lParam)
{ // {^̃Abvf[g
	return 0;
}

void CPatriotToolbar::LoadData()
{ // c[o[̐ݒ
	// eLXgɕ\
	if (!g_Options.ToolText) {
		GetToolBarCtrl().ModifyStyle(NULL , TBSTYLE_LIST);
	} else {
		GetToolBarCtrl().ModifyStyle(TBSTYLE_LIST, NULL);
	}
	// {^̑傫
	int BtX = 0 , BtY = 0;
	if (g_Options.ToolBigIcon) {
		BtX = 24;BtY = 24;
	}
	else{
		BtX = 16;BtY = 16;
	}
	/*
	if (g_Options.ToolText) {
		SetSizes(CSize(BtX+7 , BtY+19) , CSize(BtX , BtY));//CSize(23 , 35)
		SetHeight(BtY+19);
	}
	else{
		SetSizes(CSize(BtX+7 , BtY+6) , CSize(BtX , BtY));//CSize(23 , 35)
		//SetHeight(BtY+9);
	}
	*/
	// c[o[̃C[Wǂ݂
	CBitmap bmpTool;
	HANDLE hBmpBuffer;

	hBmpBuffer = ::LoadImage( NULL, g_Options.strAppPath + ((g_Options.ToolBigIcon) ?  _T("\\res\\btoolhot.bmp") : _T("\\res\\toolhot.bmp") ), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE );
	bmpTool.Attach( hBmpBuffer );

	m_imgBtnHot.DeleteImageList();
	m_imgBtnHot.Create( BtX, BtY, ILC_MASK | ILC_COLOR16, 0, 30 );
	m_imgBtnHot.Add( &bmpTool, RGB(255, 0, 255) );
	GetToolBarCtrl().SetHotImageList( &m_imgBtnHot );

	bmpTool.DeleteObject();
	hBmpBuffer = ::LoadImage(NULL , g_Options.strAppPath + ((g_Options.ToolBigIcon) ?  _T("\\res\\btoolcool.bmp") : _T("\\res\\toolcool.bmp") ), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	bmpTool.Attach( hBmpBuffer );

	m_imgBtnCool.DeleteImageList();
	m_imgBtnCool.Create(BtX , BtY , ILC_MASK | ILC_COLOR16 , 0 , 30);
	m_imgBtnCool.Add( &bmpTool, RGB(255, 0, 255) );
	GetToolBarCtrl().SetImageList( &m_imgBtnCool );

	// Disable
	CString strImagePath = g_Options.strAppPath + ((g_Options.ToolBigIcon) ? _T("\\res\\btooldis.bmp") : _T("\\res\\tooldis.bmp") );
	BOOL bPathExists = ::PathFileExists(strImagePath);
	if (bPathExists) {
		HANDLE hBmpDisable = ::LoadImage(NULL, strImagePath, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
		CBitmap bmpDisable;
		bmpDisable.Attach(hBmpDisable);

		m_imgBtnDisabled.DeleteImageList();
		m_imgBtnDisabled.Create( BtX, BtY, ILC_MASK | ILC_COLOR16, 0, 30 );
		m_imgBtnDisabled.Add( &bmpDisable, RGB(255, 0, 255) );
		GetToolBarCtrl().SetDisabledImageList(&m_imgBtnDisabled);
	}
	LoadData2();
	//	bChild = FALSE;
}

typedef struct _ButtonSetting{
	int 	nID;
	CString strLabel;
	int 	nBitmap;
} ButtonSetting;

typedef std::vector<ButtonSetting> ButtonSettingVector;

void CPatriotToolbar::LoadData2()
{ // {^̓ǂݍ
	int arrCheckMenu[] = { ID_FILE_OFFLINE, ID_TOOL_ACTIVETAB, ID_TOOL_ANTIPOPUP, ID_TOOL_CLOSEERRORDLG, ID_TOOL_LOADACTIVEX, ID_TOOL_LOADBGM, ID_TOOL_LOADIMAGE, ID_TOOL_LOADMOVIE, ID_TOOL_NEWWINDOW, ID_TOOL_RUNACTIVEX, ID_TOOL_RUNJAVA, ID_TOOL_RUNSCRIPT, ID_TOOL_SHOWSTATUS, ID_TOOL_TABLOCK, ID_TOOL_USECOOKIE, ID_TOOL_USECOOKIESESSION, ID_TOOL_USEDLG, ID_VIEW_ADDRESSBAR, ID_VIEW_AUTOREFRESH, ID_VIEW_FIXEDBAR, ID_VIEW_KEYBOARD, ID_VIEW_REBAR2, ID_VIEW_SEARCHBAR, ID_VIEW_SIDEBAR, ID_VIEW_SIDEFAVORITES, ID_VIEW_SIDEHISTRY, ID_VIEW_SIDETAB, ID_VIEW_SIDEURLLIST, ID_VIEW_SIDE_AUTOHIDE, ID_VIEW_TABBAR, 0 };
	int arrDropDownMenu[] = { ID_FILE_NEW, ID_FILE_OPEN, ID_VIEW_BACK, ID_VIEW_FORWARD, ID_FILE_CLOSEALL, ID_VIEW_FONTSIZE, ID_TOOL_LOADIMAGE, ID_TOOL_RUNSCRIPT, ID_TOOL_USECOOKIE, ID_TOOL_SENDURL, ID_TOOL_SENDSTRING, ID_TOOL_OPTION, 0 };

	CString str;

	static int nStringIndexMargin = 0;
	if (GetToolBarCtrl().GetButtonCount() > 0) {
		if (!GetButtonText(0).IsEmpty()) {
			nStringIndexMargin += GetToolBarCtrl().GetButtonCount();
		}

		// ̃{^폜
		while (GetToolBarCtrl().GetButtonCount() > 0) {
			GetToolBarCtrl().DeleteButton(0);
		}
		m_arrButton.RemoveAll();
	}

	// `t@Cǂݍ
	ButtonSettingVector arrButtonDef;
	//CStdioFile fileDefine( g_Options.strAppPath + _T("\\res\\toolbar.dat"), CFile::modeRead);
	CReadTextFile fileDefine( g_Options.strAppPath + _T("\\res\\toolbar.dat"), CFile::modeRead);

	while (fileDefine.ReadString(str)) {
		ButtonSetting button;
		// CmdID
		CString strCmd;
		SplitStr(str, _T(','), strCmd, str);
		button.nID = _ttoi( strCmd );
		// x
		SplitStr(str, _T(','), button.strLabel, str);
		// Bitmap
		button.nBitmap = _ttoi(str);

		arrButtonDef.push_back(button);
	}

	// t@Cǂݍ
	TBBUTTON BT[100] = {0};
	int nIndex = 0;
	int nStringIndex = 0;
	//CStdioFile fileImpl( g_Options.strOptionPath + _T("\\toolbar.dat"), CFile::modeRead );
	CReadTextFile fileImpl( g_Options.strOptionPath + _T("\\toolbar.dat"), CFile::modeRead );

	while ( fileImpl.ReadString(str) ) {
		int nCmd = _ttoi(str);
		if (nCmd <= 0) {
			// Zp[^
			BT[nIndex].iBitmap		= 0;
			BT[nIndex].idCommand	= 0;
			BT[nIndex].fsState		= 0;
			BT[nIndex].iString		= 0;
			BT[nIndex].fsStyle		= TBSTYLE_SEP;

			m_arrButton.Add( "---" );
		} else{
			// {^
			for (ButtonSettingVector::iterator i = arrButtonDef.begin(); i != arrButtonDef.end(); i++ ) {
				ButtonSetting* pButton = &(*i);
				int j;

				if (pButton->nID == nCmd) {
					BT[nIndex].iBitmap	 = pButton->nBitmap;
					BT[nIndex].idCommand = pButton->nID;
					BT[nIndex].fsState	 = TBSTATE_ENABLED;
					BT[nIndex].fsStyle	 = TBSTYLE_BUTTON | TBSTYLE_AUTOSIZE;
					BT[nIndex].iString	 = nStringIndex + nStringIndexMargin;

					// `FbN}[Nn
					for ( j=0 ; arrCheckMenu[j]!=0 ;j++ ) {
						if ( nCmd == arrCheckMenu[j] ) {
							BT[nIndex].fsStyle |= TBSTYLE_CHECK;
							break;
						}
					}
					// hbv_E
					for ( j=0 ; arrDropDownMenu[j]!=0 ;j++ ) {
						if ( nCmd == arrDropDownMenu[j] ) {
							BT[nIndex].fsStyle |= TBSTYLE_DROPDOWN;
							break;
						}
					}
					// c[o[̃eLXg\
					if (g_Options.ToolText) {
						BT[nIndex].fsStyle |= BTNS_SHOWTEXT;
						nStringIndex++;

						// NULLtĒǉ
						TCHAR strBuffer[MAX_PATH];
						lstrcpyn(strBuffer, pButton->strLabel, MAX_PATH - 1);
						strBuffer[ pButton->strLabel.GetLength() + 1 ] =_T('\0');
						GetToolBarCtrl().AddStrings( strBuffer );

					} else {
						BT[nIndex].fsStyle &= ~BTNS_SHOWTEXT;
						BT[nIndex].iString = NULL;
					}
					m_arrButton.Add( pButton->strLabel );
				}
			}
		}
		nIndex++;
	}
	// note: XP + VisualStyle L̂Ƃɂ̓hbv_E̃{^Kvȏɑ傫ȂB
	//		  ǉ̒OɃhbv_EꎞIɖɂ
	BOOL bStyleModified = FALSE;
	DWORD dwExtendedStyle = GetToolBarCtrl().GetExtendedStyle();
	if (!g_Options.ToolBigIcon && !g_Options.ToolText) {
		if (dwExtendedStyle & TBSTYLE_EX_DRAWDDARROWS) {
			GetToolBarCtrl().SetExtendedStyle(dwExtendedStyle &~ TBSTYLE_EX_DRAWDDARROWS);
			bStyleModified = TRUE;
		}
	}

	// c[o[ɍ\̂ǉ
	int nCount = nIndex;
	GetToolBarCtrl().AddButtons( nCount, BT );
	GetToolBarCtrl().AutoSize();
	DoEvents();

	if (bStyleModified) {
		GetToolBarCtrl().SetExtendedStyle(dwExtendedStyle);
	}
}

void CPatriotToolbar::OnRButtonDown(UINT nFlags, CPoint point)
{
	OnIdleUpdateCmdUI( 0, 0 );

	CMenu menu;
	menu.CreatePopupMenu();
	menu.AppendMenu( MF_STRING		, ID_VIEW_REBAR2		, _T("ŉB(&R)")			);
	menu.AppendMenu( MF_STRING		, ID_VIEW_FIXEDBAR		, _T("o[Œ(&Z)")			);
	menu.AppendMenu( MF_SEPARATOR	, 0 					, _T("------------")			);
	menu.AppendMenu( MF_STRING		, ID_TOOL_OPTION_TOOLBAR, _T("c[o[̕ҏW(&T)...") );

	ClientToScreen( &point );
	menu.TrackPopupMenu( TPM_LEFTALIGN, point.x, point.y, AfxGetMainWnd(), NULL );
	CToolBar::OnRButtonDown(nFlags, point);
}

BOOL CPatriotToolbar::PreTranslateMessage(MSG* pMsg)
{
	switch(pMsg->message){
	case WM_ERASEBKGND:
		return TRUE;
	}
	return CToolBar::PreTranslateMessage(pMsg);
}
