///////////////////////////////////////////////////////////////////
// TravellogManager.h
// ߂iޗǗNX
///////////////////////////////////////////////////////////////////

#pragma once

class CPatriotView;
extern const int TRAVELLOG_MAX_COUNT;

///////////////////////////////////////////////////////////////////
/// CTravellogEntry
///////////////////////////////////////////////////////////////////

class CTravelLogEntry
{
public:
	CString title;
	CString URL;

	void Empty()
	{
		title.Empty();
		URL.Empty();
	}

	CTravelLogEntry& operator = (CTravelLogEntry entry)
	{
		title = entry.title;
		URL   = entry.URL;
		return *this;
	}
};



///////////////////////////////////////////////////////////////////
/// CTravellogManager
///////////////////////////////////////////////////////////////////

class CTravelLogManager
{
public:
	enum{STATE_NONE, STATE_LOADED, STATE_RESTORE};
	enum{MENU_BACK, MENU_FORWARD};

protected:
	CPatriotView*	 m_pView;
	int 			 m_state;

	CTravelLogEntry* m_pBackEntries;
	CTravelLogEntry* m_pForwardEntries;

public:
	/// RXgN^
	CTravelLogManager(CPatriotView* pView);

	/// fXgN^
	~CTravelLogManager();

	/// ǂݍ
	void Load();

	/// 𕜌
	void Restore();

	/// j
	void Clear();

	/// j[쐬
	void CreateMenu(CMenu* pMenu, int direction);

	/// Rs[
	void Copy(CTravelLogManager* src);

	/// Rs[
	void Copy(CTravelLogEntry* pBackEntries, CTravelLogEntry* pForwardEntries);

	/// Rs[
	void CopyTo(CTravelLogEntry* pBackEntries, CTravelLogEntry* pForwardEntries);

	/// state
	int GetState(){ return m_state; }

	// state
	void SetState(int state){ m_state = state; }

protected:
	/// ߂Eiޗǂݍ
	int LoadTravelLog(int direction);

	/// ߂Eiޗ𕜌
	int RestoreTravelLog(int direction);

	/// Xgɂ
	CTravelLogEntry* EmptyEntryList(CTravelLogEntry* pEntries);

	/// XgRs[
	CTravelLogEntry* CopyEntryList(CTravelLogEntry* pEntriesTo, CTravelLogEntry* pEntriesFrom);
};